/* this program tests all cms sounds */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>



void main(int argc,char *argv[]);
void setpitch(int,int);
void setnpitch(int,int);
void setpan(int,int);

int pa[12]={3,31,58,83,107,130,151,172,191,209,226,242};
int onoise=0;

void main(int argc,char *argv[])
{
int i,j;
long l;

printf("Testing all CMS sounds and noises of Sound Blaster\n");
printf("Press any key to advance to next sound/noise\n\n");

if (argc==2)
  if (tolower(argv[1][0])=='n')
    onoise=1;

for (i=0; i < 0x20; i++)	/* reset everything to zero */
  {
  outp(0x221,i);
  outp(0x220,0);
  outp(0x223,i);
  outp(0x222,0);
  }


outp(0x221,0x1c);
outp(0x220,2);
outp(0x220,1);		/* cms sounds reset */
outp(0x223,0x1c);
outp(0x222,2);
outp(0x222,1);
outp(0x221,0x15);
outp(0x220,0);		/* noise off first */
outp(0x223,0x15);
outp(0x222,0);
outp(0x221,0x14);
outp(0x220,0);		/* freq off first */
outp(0x223,0x14);
outp(0x222,0);
outp(0x221,0x16);
outp(0x220,0);		/* noises max freq */
outp(0x223,0x16);
outp(0x222,0);

for (i=0; i < 6; i++)	/* set default volumes */
  {
  outp(0x221,i);
  outp(0x220,0x88);
  outp(0x223,i);
  outp(0x222,0x88);
  }

if (onoise)
  goto onnoise;

for (i=0; i < 12; i++)		/* test sounds */
  {
  printf("Testing sound %d\n",i+1);

  for (j=0; j < 8*12; j++)	/* test all pitches */
    {
    setpitch(i,j);
    for (l=0L; l < 10000L; l++) ;
    }
  setpitch(i,39);		/* middle c */
  for (j=0; j < 64; j++)	/* test balance */
    {
    setpan(i,j);
    for (l=0L; l < 20000L; l++) ;
    }

  getch();
  outp(0x221+(i/6)*2,0x14);
  outp(0x220+(i/6)*2,0);
  }

for (i=0; i < 6; i++)	/* set default volumes */
  {
  outp(0x221,i);
  outp(0x220,0x88);
  outp(0x223,i);
  outp(0x222,0x88);
  }

onnoise:
for (i=0; i < 12; i++)		/* test noises */
  {
  printf("Testing noise %d\n",i+1);

  for (j=2; j >= 0; j--)	/* test all pitches */
    {
    setnpitch(i,j);
    for (l=0L; l < 400000L; l++) ;
    }
  setnpitch(i,0);		/* middle c */
  for (j=0; j < 64; j++)	/* test balance */
    {
    setpan(i,j);
    for (l=0L; l < 20000L; l++) ;
    }

  getch();
  outp(0x221+(i/6)*2,0x15);
  outp(0x220+(i/6)*2,0);
  }

outp(0x221,0x1c);
outp(0x220,0);
outp(0x223,0x1c);	/* sounds off */
outp(0x222,0);


exit(0);
}
/* ------------------------------------------------------------ */
/* sound set */
void setpitch(int sound,int pitch)
{
int cad=0x221+(sound/6)*2;
int dad=0x220+(sound/6)*2;

outp(cad,sound%6);
outp(dad,0);			/* disable sound first */

outp(cad,0x10+((sound%6)/2));
outp(dad,(pitch/12)<<((sound&1)*4)); /* octave set */

outp(cad,8+sound%6);
outp(dad,pa[pitch%12]);		/* pitch within octave set */

outp(cad,0x14);
outp(dad,1<<(sound%6));		/* sound enable */

outp(cad,sound%6);
outp(dad,0x88);			/* set default volume/pan */
}
/* ------------------------------------------------------------ */
/* noise set */
void setnpitch(int sound,int pitch)
{
int cad=0x221+(sound/6)*2;
int dad=0x220+(sound/6)*2;

outp(cad,sound%6);
outp(dad,0);			/* disable sound first */

outp(cad,0x16);
outp(dad,pitch<<(((sound/3)&1)*4));		/* noise pitch set */

outp(cad,0x15);
outp(dad,1<<(sound%6));		/* noise enable */

outp(cad,sound%6);
outp(dad,0x88);			/* set default volume/pan */
}
/* ------------------------------------------------------------ */
void setpan(int sound,int pan)
{
int cad=0x221+(sound/6)*2;
int dad=0x220+(sound/6)*2;
int pval=0;

if (pan < 16)
  pval|=pan;
else if (pan <32)
  {
  pval|=15;
  pval|=(pan-16)<<4;
  }
else if (pan<48)
  {
  pval|=47-pan;
  pval|=15<<4;
  }
else
  pval|=(63-pan)<<4;

outp(cad,sound%6);
outp(dad,pval);
}
